package org.dromara.shebei.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.shebei.domain.bo.OpsSbMobanBo;
import org.dromara.shebei.domain.vo.OpsSbMobanVo;
import org.dromara.shebei.domain.OpsSbMoban;
import org.dromara.shebei.mapper.OpsSbMobanMapper;
import org.dromara.shebei.service.IOpsSbMobanService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 运维-设备管理-设备模板Service业务层处理
 *
 * @author LionLi
 * @date 2025-10-09
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class OpsSbMobanServiceImpl extends ServiceImpl<OpsSbMobanMapper, OpsSbMoban> implements IOpsSbMobanService {

    private final OpsSbMobanMapper baseMapper;

    /**
     * 查询运维-设备管理-设备模板
     *
     * @param id 主键
     * @return 运维-设备管理-设备模板
     */
    @Override
    public OpsSbMobanVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询运维-设备管理-设备模板列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 运维-设备管理-设备模板分页列表
     */
    @Override
    public TableDataInfo<OpsSbMobanVo> queryPageList(OpsSbMobanBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<OpsSbMoban> lqw = buildQueryWrapper(bo);
        Page<OpsSbMobanVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的运维-设备管理-设备模板列表
     *
     * @param bo 查询条件
     * @return 运维-设备管理-设备模板列表
     */
    @Override
    public List<OpsSbMobanVo> queryList(OpsSbMobanBo bo) {
        LambdaQueryWrapper<OpsSbMoban> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<OpsSbMoban> buildQueryWrapper(OpsSbMobanBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<OpsSbMoban> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(OpsSbMoban::getId);
        lqw.eq(bo.getProjectId() != null, OpsSbMoban::getProjectId, bo.getProjectId());
        lqw.like(StringUtils.isNotBlank(bo.getMbName()), OpsSbMoban::getMbName, bo.getMbName());
        lqw.eq(bo.getBlCount() != null, OpsSbMoban::getBlCount, bo.getBlCount());
        lqw.eq(bo.getSbCount() != null, OpsSbMoban::getSbCount, bo.getSbCount());
        return lqw;
    }

    /**
     * 新增运维-设备管理-设备模板
     *
     * @param bo 运维-设备管理-设备模板
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(OpsSbMobanBo bo) {
        OpsSbMoban add = MapstructUtils.convert(bo, OpsSbMoban.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改运维-设备管理-设备模板
     *
     * @param bo 运维-设备管理-设备模板
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(OpsSbMobanBo bo) {
        OpsSbMoban update = MapstructUtils.convert(bo, OpsSbMoban.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(OpsSbMoban entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除运维-设备管理-设备模板信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
